with C;
package bits.types is

    BITS_TYPES_H                : constant  := 1;
                                                -- /usr/include/bits/types.h:25
    need_size_t                 : constant Boolean := True;
                                                -- /usr/include/bits/types.h:30

    type u_char is new C.unsigned_char;         -- /usr/include/bits/types.h:34
    type u_short is new C.unsigned_short;       -- /usr/include/bits/types.h:35
    type u_int is new C.unsigned_int;           -- /usr/include/bits/types.h:36
    type u_long is new C.unsigned_long;         -- /usr/include/bits/types.h:37
    type int8_t is new C.signed_char;           -- /usr/include/bits/types.h:40
    type uint8_t is new C.unsigned_char;        -- /usr/include/bits/types.h:41
    type int16_t is new C.short;                -- /usr/include/bits/types.h:42
    type uint16_t is new C.unsigned_short;      -- /usr/include/bits/types.h:43
    type int32_t is new C.int;                  -- /usr/include/bits/types.h:44
    type uint32_t is new C.unsigned_int;        -- /usr/include/bits/types.h:45
    type uid_t is new C.unsigned_int;          -- /usr/include/bits/types.h:138
    type gid_t is new C.unsigned_int;          -- /usr/include/bits/types.h:139
    type ino_t is new C.unsigned_long;         -- /usr/include/bits/types.h:140
    type mode_t is new C.unsigned_int;         -- /usr/include/bits/types.h:142
    type nlink_t is new C.unsigned_int;        -- /usr/include/bits/types.h:143
    type off_t is new C.long;                  -- /usr/include/bits/types.h:144
    type pid_t is new C.int;                   -- /usr/include/bits/types.h:146
    type clock_t is new C.long;                -- /usr/include/bits/types.h:148
    type rlim_t is new C.unsigned_long;        -- /usr/include/bits/types.h:149
    type id_t is new C.unsigned_int;           -- /usr/include/bits/types.h:151
    type time_t is new C.long;                 -- /usr/include/bits/types.h:152
    type useconds_t is new C.unsigned_int;     -- /usr/include/bits/types.h:153
    type suseconds_t is new C.long;            -- /usr/include/bits/types.h:154
    type daddr_t is new C.int;                 -- /usr/include/bits/types.h:156
    type swblk_t is new C.long;                -- /usr/include/bits/types.h:157
    type key_t is new C.int;                   -- /usr/include/bits/types.h:158
    type clockid_t is new C.int;               -- /usr/include/bits/types.h:161
    type blksize_t is new C.long;              -- /usr/include/bits/types.h:167
    type blkcnt_t is new C.long;               -- /usr/include/bits/types.h:172
    type fsblkcnt_t is new C.unsigned_long;    -- /usr/include/bits/types.h:176
    type fsfilcnt_t is new C.unsigned_long;    -- /usr/include/bits/types.h:180
    type ssize_t is new C.int;                 -- /usr/include/bits/types.h:183
    type intptr_t is new C.int;                -- /usr/include/bits/types.h:192
    type socklen_t is new C.unsigned_int;      -- /usr/include/bits/types.h:195

    type timer_t is new System.Address;        -- /usr/include/bits/types.h:164
    type caddr_t is access all C.char;         -- /usr/include/bits/types.h:189

    type long_array is                          -- /usr/include/bits/types.h:64
        array(C.natural_int range <>)
        of aliased C.long;

    type u_long_array is                        -- /usr/include/bits/types.h:68
        array(C.natural_int range <>)
        of aliased u_long;

    type int_array is                          -- /usr/include/bits/types.h:147
        array(C.natural_int range <>)
        of aliased C.int;

    type quad_t;                                -- /usr/include/bits/types.h:65
    type u_quad_t;                              -- /usr/include/bits/types.h:69
    type fsid_t;                               -- /usr/include/bits/types.h:147

    type quad_t_access is access all quad_t;   -- /usr/include/bits/types.h:188
    type qaddr_t is access all quad_t;         -- /usr/include/bits/types.h:188

    type quad_t is                              -- /usr/include/bits/types.h:65
        record
            val: aliased long_array(0..1);      -- /usr/include/bits/types.h:64
        end record;


    type u_quad_t is                            -- /usr/include/bits/types.h:69
        record
            val_c0: aliased u_long_array(0..1); -- /usr/include/bits/types.h:68
        end record;


    subtype dev_t is u_quad_t;                 -- /usr/include/bits/types.h:137

    subtype ino64_t is u_quad_t;               -- /usr/include/bits/types.h:141

    subtype off64_t is quad_t;                 -- /usr/include/bits/types.h:145

    type fsid_t is                             -- /usr/include/bits/types.h:147
        record
            val_c1: aliased int_array(0..1);   -- /usr/include/bits/types.h:147
        end record;


    subtype rlim64_t is u_quad_t;              -- /usr/include/bits/types.h:150

    subtype blkcnt64_t is quad_t;              -- /usr/include/bits/types.h:173

    subtype fsblkcnt64_t is u_quad_t;          -- /usr/include/bits/types.h:177

    subtype fsfilcnt64_t is u_quad_t;          -- /usr/include/bits/types.h:181

    subtype loff_t is off64_t;                 -- /usr/include/bits/types.h:187
    subtype __S16_TYPE is C.int;               -- /usr/include/bits/types.h:102
    subtype __U16_TYPE is C.unsigned_int;      -- /usr/include/bits/types.h:103
    subtype __S32_TYPE is C.int;               -- /usr/include/bits/types.h:104
    subtype __U32_TYPE is C.unsigned_int;      -- /usr/include/bits/types.h:105
    subtype __SLONGWORD_TYPE is C.long;        -- /usr/include/bits/types.h:106
    subtype __ULONGWORD_TYPE is C.unsigned_long;
                                               -- /usr/include/bits/types.h:107
    subtype __SQUAD_TYPE is quad_t;            -- /usr/include/bits/types.h:109
    subtype __UQUAD_TYPE is u_quad_t;          -- /usr/include/bits/types.h:110
    subtype __SWORD_TYPE is C.int;             -- /usr/include/bits/types.h:111
    subtype __UWORD_TYPE is C.unsigned_int;    -- /usr/include/bits/types.h:112
    subtype __SLONG32_TYPE is C.long;          -- /usr/include/bits/types.h:113
    subtype __ULONG32_TYPE is C.unsigned_long; -- /usr/include/bits/types.h:114
    subtype __S64_TYPE is quad_t;              -- /usr/include/bits/types.h:115
    subtype __U64_TYPE is u_quad_t;            -- /usr/include/bits/types.h:116

end bits.types;
